module ExecJS
  module Rails
    class TemplateResolver < ::ActionView::Resolver

      def find_templates(name, prefix, partial, details)
        path = "#{prefix}/#{name}"
        if details[:formats].include?(:html) && Renderer.has_view(path)
          [::ActionView::Template.new(
            "<%= execjs_render('#{path}') %>",
            "ExecJS - #{path}",
            ActionView::Template.registered_template_handler(:erb),
            {
              format: Mime[:erb],
              virtual_path: path
            }
          )]
        else
          []
        end
      end

    end
  end
end
